searchNodes=[{"ref":"Merkel.html","title":"Merkel","type":"module","doc":"Essentially a driver module but allows for the decoupled addition of e.g. new tree types and/or other proof types."},{"ref":"Merkel.html#audit/2","title":"Merkel.audit/2","type":"function","doc":""},{"ref":"Merkel.html#delete/2","title":"Merkel.delete/2","type":"function","doc":""},{"ref":"Merkel.html#dump/1","title":"Merkel.dump/1","type":"function","doc":""},{"ref":"Merkel.html#insert/2","title":"Merkel.insert/2","type":"function","doc":""},{"ref":"Merkel.html#keys/1","title":"Merkel.keys/1","type":"function","doc":""},{"ref":"Merkel.html#lookup/2","title":"Merkel.lookup/2","type":"function","doc":""},{"ref":"Merkel.html#new/0","title":"Merkel.new/0","type":"function","doc":""},{"ref":"Merkel.html#new/1","title":"Merkel.new/1","type":"function","doc":""},{"ref":"Merkel.html#print/1","title":"Merkel.print/1","type":"function","doc":""},{"ref":"Merkel.html#size/1","title":"Merkel.size/1","type":"function","doc":""},{"ref":"Merkel.html#store/2","title":"Merkel.store/2","type":"function","doc":""},{"ref":"Merkel.html#to_list/1","title":"Merkel.to_list/1","type":"function","doc":""},{"ref":"Merkel.html#tree_hash/1","title":"Merkel.tree_hash/1","type":"function","doc":""},{"ref":"Merkel.html#values/1","title":"Merkel.values/1","type":"function","doc":""},{"ref":"Merkel.html#verify/2","title":"Merkel.verify/2","type":"function","doc":""},{"ref":"Merkel.AVL.html","title":"Merkel.AVL","type":"module","doc":"Implements the AVL balance rotations for a binary tree A self-balancing AVL tree ensures the tree height is always O(log n)"},{"ref":"Merkel.AVL.html#balance/3","title":"Merkel.AVL.balance/3","type":"function","doc":"Balances tree rooted at node n using avl rotations. Runs the update callback function for each node that is affected by rotations"},{"ref":"Merkel.AVL.html#balance?/1","title":"Merkel.AVL.balance?/1","type":"function","doc":"Checks whether the tree rooted at node n needs to be balanced"},{"ref":"Merkel.AVL.html#t:skey/0","title":"Merkel.AVL.skey/0","type":"type","doc":""},{"ref":"Merkel.Audit.html","title":"Merkel.Audit","type":"module","doc":"Module facilitates audit proof creation given the candidate key as well as providing verification of the proof. The audit proof simply contains the candidate key and the audit path in tuple form that eliminates any need to store an index or other overhead to track key position. The construction of the tuple encodes the proper hash concatenation order. &quot;The purpose of the Merkle tree [in Bitcoin] is to allow the data in a block to be delivered piecemeal: a node can download only the header of a block from one source, the small part of the tree relevant to them from another source, and still be assured that all of the data is correct. The reason why this works is that hashes propagate upward: if a malicious user attempts to swap in a fake transaction into the bottom of a Merkle tree, this change will cause a change in the node above, and then a change in the node above that, finally changing the root of the tree and therefore the hash of the block, causing the protocol to register it as a completely different block (almost certainly with an invalid proof of work)&quot; Ethereum (https://github.com/ethereum/wiki/wiki/White-Paper#merkle-trees)"},{"ref":"Merkel.Audit.html#create/2","title":"Merkel.Audit.create/2","type":"function","doc":"Create audit proof This includes the set of sibling hashes in the path to the merkle root, that will ensure verification"},{"ref":"Merkel.Audit.html#length/1","title":"Merkel.Audit.length/1","type":"function","doc":"Returns audit trail path length"},{"ref":"Merkel.Audit.html#verify/2","title":"Merkel.Audit.verify/2","type":"function","doc":"Verify the candidate key and audit path are authenticated as part of the merkle tree"},{"ref":"Merkel.Audit.html#t:t/0","title":"Merkel.Audit.t/0","type":"type","doc":""},{"ref":"Merkel.BinaryHashTree.html","title":"Merkel.BinaryHashTree","type":"module","doc":"Implements a merkle binary hash tree that is balanced using AVL rotations Supports create, lookup, keys, insert, delete operations Given an initial list of k-v pairs constructs an initial balanced tree without any initial rotations or initial rehashings Keys are binary, e.g. a utf8 encoded sequence of bytes (string) or just bytes Values are any type (use your discretion if you want the tree to be more compact) Keys and values are only stored in the leaves Inner nodes use the search_key value to determine order Hashes of the keys are stored in the node key_hash field Inner nodes store the concatenated hashes of their children in key_hash as well"},{"ref":"Merkel.BinaryHashTree.html#create/0","title":"Merkel.BinaryHashTree.create/0","type":"function","doc":"Create balanced tree given a list of {k,v} pairs or create empty tree Given a list of atom key and binary value pairs, the atom options are :etf and :path to support creation from either a merkel etf binary or a file containing a merkel etf binary"},{"ref":"Merkel.BinaryHashTree.html#create/1","title":"Merkel.BinaryHashTree.create/1","type":"function","doc":""},{"ref":"Merkel.BinaryHashTree.html#delete/2","title":"Merkel.BinaryHashTree.delete/2","type":"function","doc":"Delete the specified key, ensuring it resides in the tree.Updates binary tree search keys"},{"ref":"Merkel.BinaryHashTree.html#dump/1","title":"Merkel.BinaryHashTree.dump/1","type":"function","doc":"Convert tree to erlang term format"},{"ref":"Merkel.BinaryHashTree.html#info/1","title":"Merkel.BinaryHashTree.info/1","type":"function","doc":"Provides dump of tree info to be used in Inspect protocol implementation"},{"ref":"Merkel.BinaryHashTree.html#insert/2","title":"Merkel.BinaryHashTree.insert/2","type":"function","doc":"Adds key value pair and then ensures tree is balanced."},{"ref":"Merkel.BinaryHashTree.html#keys/1","title":"Merkel.BinaryHashTree.keys/1","type":"function","doc":"Returns list of keys from bottom left of tree to bottom right"},{"ref":"Merkel.BinaryHashTree.html#lookup/2","title":"Merkel.BinaryHashTree.lookup/2","type":"function","doc":"Returns key value pair if key lookup is successful"},{"ref":"Merkel.BinaryHashTree.html#size/1","title":"Merkel.BinaryHashTree.size/1","type":"function","doc":""},{"ref":"Merkel.BinaryHashTree.html#store/2","title":"Merkel.BinaryHashTree.store/2","type":"function","doc":"Store tree to file path p, in erlang term format"},{"ref":"Merkel.BinaryHashTree.html#to_list/1","title":"Merkel.BinaryHashTree.to_list/1","type":"function","doc":"Returns a list of the tree&#39;s key-value pairs in {k,v} tuple form. Pairs are extracted from the tree bottom left to bottom right."},{"ref":"Merkel.BinaryHashTree.html#tree_hash/1","title":"Merkel.BinaryHashTree.tree_hash/1","type":"function","doc":""},{"ref":"Merkel.BinaryHashTree.html#values/1","title":"Merkel.BinaryHashTree.values/1","type":"function","doc":"Returns list of values from bottom left of tree to bottom right"},{"ref":"Merkel.BinaryHashTree.html#t:key/0","title":"Merkel.BinaryHashTree.key/0","type":"type","doc":""},{"ref":"Merkel.BinaryHashTree.html#t:pair/0","title":"Merkel.BinaryHashTree.pair/0","type":"type","doc":""},{"ref":"Merkel.BinaryHashTree.html#t:t/0","title":"Merkel.BinaryHashTree.t/0","type":"type","doc":""},{"ref":"Merkel.BinaryHashTree.html#t:value/0","title":"Merkel.BinaryHashTree.value/0","type":"type","doc":""},{"ref":"Merkel.BinaryNode.html","title":"Merkel.BinaryNode","type":"module","doc":""},{"ref":"Merkel.BinaryNode.html#dump/1","title":"Merkel.BinaryNode.dump/1","type":"function","doc":"Provides raw dump of all Node info"},{"ref":"Merkel.BinaryNode.html#info/1","title":"Merkel.BinaryNode.info/1","type":"function","doc":"Provides node info to be used in Inspect protocol implementation"},{"ref":"Merkel.BinaryNode.html#root_info/1","title":"Merkel.BinaryNode.root_info/1","type":"function","doc":"Provides dump of node info for root node"},{"ref":"Merkel.BinaryNode.html#trunc_hash_key/1","title":"Merkel.BinaryNode.trunc_hash_key/1","type":"function","doc":""},{"ref":"Merkel.BinaryNode.html#trunc_search_key/1","title":"Merkel.BinaryNode.trunc_search_key/1","type":"function","doc":""},{"ref":"Merkel.BinaryNode.html#t:t/0","title":"Merkel.BinaryNode.t/0","type":"type","doc":""},{"ref":"Merkel.Crypto.html","title":"Merkel.Crypto","type":"module","doc":"Module to perform merkle tree hashing"},{"ref":"Merkel.Crypto.html#hash/1","title":"Merkel.Crypto.hash/1","type":"function","doc":"Performs hash Either uses the default Erlang crypto library or accepts a user specified anonymous function with arity 1 which accepts a binary argument"},{"ref":"Merkel.Crypto.html#hash/2","title":"Merkel.Crypto.hash/2","type":"function","doc":""},{"ref":"Merkel.Crypto.html#hash/3","title":"Merkel.Crypto.hash/3","type":"function","doc":""},{"ref":"Merkel.Crypto.html#hash_concat/2","title":"Merkel.Crypto.hash_concat/2","type":"function","doc":"Public helper routine to concat hashes takes hash binaries or Nodes as args"},{"ref":"Merkel.Crypto.html#sha256_2_hash/1","title":"Merkel.Crypto.sha256_2_hash/1","type":"function","doc":"Public helper for bitcoin double hash"},{"ref":"Merkel.Helper.html","title":"Merkel.Helper","type":"module","doc":"Module assists in tree creation"},{"ref":"Merkel.Helper.html#create_tree/2","title":"Merkel.Helper.create_tree/2","type":"function","doc":"Public helper to create the tree with an option to specify and vary the heavier tree side when we don&#39;t have an equal number of nodes :)"},{"ref":"Merkel.Helper.html#inner/3","title":"Merkel.Helper.inner/3","type":"function","doc":""},{"ref":"Merkel.Helper.html#leaf/1","title":"Merkel.Helper.leaf/1","type":"function","doc":""},{"ref":"Merkel.Helper.html#t:key/0","title":"Merkel.Helper.key/0","type":"type","doc":""},{"ref":"Merkel.Helper.html#t:pair/0","title":"Merkel.Helper.pair/0","type":"type","doc":""},{"ref":"Merkel.Printer.html","title":"Merkel.Printer","type":"module","doc":"Module implements pretty printing of merkle binary hash tree"},{"ref":"Merkel.Printer.html#pretty_print/1","title":"Merkel.Printer.pretty_print/1","type":"function","doc":"Prints the merkle binary hash tree rotated to the left 90 degrees so that large trees will fit in the console window We perform a &quot;reverse inorder search&quot; and display the tree rotated left Inorder is typical left-node-right, but in this case we are doing right-node-left The rightmost on the first line, all the way down to the leftmost which is one the last line So given tree: R This will be printed as: 4 / 3 4 R 3 Base case if root is nil, stop recursing and return back The closer we are to the leaves, indent is higher, the closer to the root index is smaller"}]